import 'dart:async';
import 'package:flutter/services.dart';
import 'dart:ui';

import 'CallbackDispatcher.dart';

class TcgLocation {
  static const MethodChannel _channel =
      const MethodChannel('tcg_location');
  static const MethodChannel _background = MethodChannel('tcg_location_background');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<bool> initialize() async {
    final CallbackHandle callback = PluginUtilities.getCallbackHandle(callbackDispatcher);
    final bool initialized = await _channel.invokeMethod('initialize', <dynamic>[callback.toRawHandle()]);
    return initialized;
  }

  static Future<bool> startLocation(Function(String data) callback) async {

    CallbackHandle handle = PluginUtilities.getCallbackHandle(callback);
    final List<dynamic> args = <dynamic>[
      handle.toRawHandle()
    ];
    final bool initialized = await _channel.invokeMethod('startLocation', args);
    return initialized;
  }

  static Future<bool> stopLocation() async {
    final bool stopped = await _channel.invokeMethod('stopLocation');
    return stopped;
  }

  static Future<String> get sampleLocation async {

    final String sampleLocation = await _channel.invokeMethod('getSampleLocation');
    return sampleLocation;
  }


}
